var key,__defProp=Object.defineProperty;import{d as TRANSACTION_STATUS,e as TRANSACTION_STORAGE_KEY}from"./Bp1d0l6t.js";import{b as generateTransactionId}from"./5psteQTW.js";class TransactionQueue{static async init(){const transactionsStore=await this.getAllTransactions(),now=Date.now();for(const txArray of Object.values(transactionsStore))for(const tx of txArray)tx.status!==TRANSACTION_STATUS.CREATED&&tx.status!==TRANSACTION_STATUS.PENDING||(now-tx.createTimestamp>this.AUTO_COMPLETE_DELAY_MS?await this.completeTransaction(tx.createTimestamp):setTimeout((()=>{this.completeTransaction(tx.createTimestamp)}),this.AUTO_COMPLETE_DELAY_MS-(now-tx.createTimestamp)))}static async getAllTransactions(){return(await chrome.storage.session.get([TRANSACTION_STORAGE_KEY]))[TRANSACTION_STORAGE_KEY]||{}}static async saveAllTransactions(transactionsStore){const oldStore=(await chrome.storage.session.get([TRANSACTION_STORAGE_KEY]))[TRANSACTION_STORAGE_KEY]||{};JSON.stringify(oldStore)!==JSON.stringify(transactionsStore)&&await chrome.storage.session.set({[TRANSACTION_STORAGE_KEY]:transactionsStore})}static async addTransaction(partialTransaction){const generatedId=generateTransactionId(partialTransaction.chain,partialTransaction.tokenAddress,partialTransaction.type,partialTransaction.amount),transactionsStore=await this.getAllTransactions(),existingArray=transactionsStore[generatedId]||[];if(existingArray.find((t=>t.status===TRANSACTION_STATUS.CREATED||t.status===TRANSACTION_STATUS.PENDING)))throw new Error(`Transaction with ID "${generatedId}" is already in an active state (created/pending).`);const newTransaction={id:generatedId,createTimestamp:Date.now(),updateTimestamp:null,...partialTransaction};return existingArray.push(newTransaction),transactionsStore[generatedId]=existingArray,await this.saveAllTransactions(transactionsStore),newTransaction}static async updateTransaction(createTimestamp,changes){const transactionsStore=await this.getAllTransactions();let updatedTx=null;for(const[txId,txArray]of Object.entries(transactionsStore)){const index=txArray.findIndex((t=>t.createTimestamp===createTimestamp));if(-1!==index){const newTx={...txArray[index],...changes,updateTimestamp:Date.now()};txArray[index]=newTx,transactionsStore[txId]=txArray,updatedTx=newTx;break}}return updatedTx?(await this.saveAllTransactions(transactionsStore),changes.status!==TRANSACTION_STATUS.SUCCEEDED&&changes.status!==TRANSACTION_STATUS.FAILED||setTimeout((()=>{this.removeTransaction(createTimestamp)}),this.AUTO_COMPLETE_DELAY_MS),updatedTx):null}static async removeTransaction(createTimestamp){const transactionsStore=await this.getAllTransactions();let didRemove=!1;for(const[txId,txArray]of Object.entries(transactionsStore)){const filtered=txArray.filter((t=>t.createTimestamp!==createTimestamp));if(filtered.length!==txArray.length){didRemove=!0,0===filtered.length?delete transactionsStore[txId]:transactionsStore[txId]=filtered;break}}return didRemove&&await this.saveAllTransactions(transactionsStore),didRemove}static async clearAll(){await this.saveAllTransactions({})}static async completeTransaction(createTimestamp){await this.updateTransaction(createTimestamp,{status:TRANSACTION_STATUS.COMPLETED})}static async checkTransaction(address,chain,trigger,amount){const txArray=(await this.getAllTransactions())[generateTransactionId(chain,address,trigger,amount)]||[];return 0===txArray.length?null:txArray[txArray.length-1].status}}((obj,key)=>{key in obj?__defProp(obj,key,{enumerable:!0,configurable:!0,writable:!0,value:2e3}):obj[key]=2e3})(TransactionQueue,"symbol"!=typeof(key="AUTO_COMPLETE_DELAY_MS")?key+"":key);export{TransactionQueue as T};
